VERSION 5.00
Begin VB.Form frmWindow 
   Caption         =   "Server"
   ClientHeight    =   4845
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   6885
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   323
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   459
   Begin VB.PictureBox picContainer 
      BackColor       =   &H00FFFFFF&
      Height          =   4215
      Left            =   5520
      ScaleHeight     =   277
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   77
      TabIndex        =   2
      Top             =   120
      Width           =   1215
      Begin VB.ListBox lstUsers 
         Appearance      =   0  'Flat
         Height          =   4125
         Left            =   -15
         Sorted          =   -1  'True
         TabIndex        =   3
         Top             =   -15
         Width           =   1215
      End
   End
   Begin VB.TextBox txtConversation 
      Height          =   4215
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   1
      Top             =   120
      Width           =   5295
   End
   Begin VB.TextBox txtCommand 
      Height          =   285
      Left            =   120
      TabIndex        =   0
      Top             =   4440
      Width           =   6615
   End
   Begin VB.Menu mnuUser 
      Caption         =   "&User"
      Visible         =   0   'False
      Begin VB.Menu mnuOpenPrivate 
         Caption         =   "&Private ..."
      End
      Begin VB.Menu mnuLine1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuGetInfo 
         Caption         =   "&Info"
      End
      Begin VB.Menu mnuLine2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuPrivilegedUser 
         Caption         =   "&Privileged user"
      End
      Begin VB.Menu mnuKickUser 
         Caption         =   "&Kick user"
      End
      Begin VB.Menu mnuSendRPC 
         Caption         =   "&Send RPC"
      End
   End
End
Attribute VB_Name = "frmWindow"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Copyright (C) 2006 Kristian S. Stangeland

' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.

' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

' A reference to the main communication class
Public WithEvents refComm As clsCommunication
Attribute refComm.VB_VarHelpID = -1
Public ChatLog As clsLogging

' Used when defining a specific user conversation
Public PrivateRecipient As clsUser
Public PrivateSession As Boolean

' The current user of which has been selected
Private currUser As clsUser

Public Property Get PrivateName() As String

    ' Simply return the name of the private user safely
    If PrivateSession Then
        PrivateName = PrivateRecipient.UserName
    End If

End Property

Public Sub AppendLine(sText As String)

    Dim sTemp As String
    
    ' Append line in log if enabled
    If Not (ChatLog Is Nothing) Then
        ChatLog.AppendLine "[" & Time & "] " & sText
    End If
    
    ' Retrieve the current text
    sTemp = txtConversation.Text

    ' Append the line to the textbox
    txtConversation.Text = sTemp & sText & vbCrLf

    ' Move to the last line
    txtConversation.SelStart = Len(sTemp) + Len(sText) + Len(vbCrLf)
    
End Sub

Private Sub Form_Load()

    ' If a comm-object has been referenced, ...
    If Not (refComm Is Nothing) Then

        ' Create a new log as well, if we're supposed to
        If ChatApp.Settings.Setting("Logging", "Enable", True) Then
        
            ' New log class
            Set ChatLog = refComm.CreateLog(FileOperation.ValidPath(App.Path) & "Logs\" _
              & IIf(PrivateSession, PrivateName, refComm.ServerAddress) & "." & _
                DateDiff("s", CDate("01.01.0"), Now) & ".log")
        
        End If
        
        ' ... update the userlist.
        refComm_UserListChanged "", Array(refComm.LocalUser.UserName)
        
    End If

End Sub

Private Sub Form_Resize()

    ' Resize the different components
    txtConversation.Height = Me.ScaleHeight - txtCommand.Height - 24
    txtConversation.Width = Me.ScaleWidth - IIf(PrivateSession, 0, picContainer.Width + 8) - 16
    
    ' Only resize if the userlist is enabled
    If Not PrivateSession Then
        picContainer.Visible = True
        picContainer.Height = txtConversation.Height
        picContainer.Left = txtConversation.Width + 16
        lstUsers.Height = picContainer.Height + 8
    Else
        picContainer.Visible = False
    End If
    
    ' Resize the command line
    txtCommand.Width = Me.ScaleWidth - 16
    txtCommand.Top = Me.ScaleHeight - txtCommand.Height - 8
    
End Sub

Private Sub Form_Unload(Cancel As Integer)

    ' Only reintialize if this is the server window
    If Not PrivateSession Then
        
        ' Close the connection(s)
        refComm.ClearAll
    
        ' Reset to logon window again
        ChatApp.ResetApp
    
    End If
     
    ' Remove the reference to the communication class
    Set refComm = Nothing
     
End Sub

Private Sub lstUsers_DblClick()

    Dim newForm As frmWindow

    ' Create a new instance to send private messages to the selected user
    If LenB(lstUsers.Text) > 0 Then
    
        ' Add a new window
        NewSession lstUsers.Text
    
    End If

End Sub

Private Sub lstUsers_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)

    ' If this is a right click, ...
    If Button = 2 And lstUsers.Text <> "" Then
    
        ' Retrieve the current selected user
        Set currUser = refComm.FindUser(lstUsers.Text)
    
        ' Update the differnt elements
        mnuUser_Click
    
        ' ... show the appropriate menu
        Me.PopupMenu mnuUser
    
    End If

End Sub

Private Sub mnuGetInfo_Click()

    ' Show information about this particulary user
    With currUser
        AppendLine "* Information about " & lstUsers.Text & ": "
        AppendLine "* - Email: " & .UserEmail
        AppendLine "* - Address: " & .RemoteIP
        AppendLine "* - Server: " & .UserServer
        AppendLine "* - Remote: " & Not .LocalUser
        AppendLine "* - Privileged: " & .UserPrivileged
    End With

End Sub

Private Sub mnuKickUser_Click()

    ' See if we found a user by that name
    If Not (currUser Is Nothing) Then
        ' If so, kick it
        refComm.KickUser currUser
    End If

End Sub

Private Sub mnuOpenPrivate_Click()

    ' Invoke the private message dialog
    lstUsers_DblClick

End Sub

Private Sub mnuPrivilegedUser_Click()

    ' Make sure we actually found a user
    If Not (currUser Is Nothing) Then

        ' Set whether or not this user is privileged
        currUser.UserPrivileged = Not currUser.UserPrivileged
        
        ' Update user list
        refComm.RefreshList
        
        ' Update menu elements
        mnuUser_Click
    
    End If

End Sub

Private Sub mnuSendRPC_Click()

    Dim Dialog As New clsDialog, retProp As PropertyBag
    
    ' Create a new RPC-dialog
    Set Dialog.ReferenceForm = New frmRPC

    ' Show dialog and retrieve information
    Set retProp = Dialog.ShowDialog(New PropertyBag)

    ' See if the user pressed OK
    If retProp.ReadProperty("Returned") = "OK" Then
    
        ' Send the command
        refComm.SendRPC retProp.ReadProperty("txtCode"), lstUsers.Text
    
    End If

End Sub

Private Sub mnuUser_Click()

    ' Update elements
    mnuSendRPC.Enabled = refComm.IsServer Or refComm.LocalUser.UserPrivileged
    mnuPrivilegedUser.Enabled = refComm.IsServer
    mnuPrivilegedUser.Checked = currUser.UserPrivileged
    mnuKickUser.Enabled = mnuSendRPC.Enabled
    
End Sub

Private Sub refComm_Connected()

    ' Inform about the connection
    AppendLine "Connected to server " & Time & "!"

End Sub

Private Sub refComm_Disconnected()

    ' Inform about this event
    If Not (ChatLog Is Nothing) Then
        ChatLog.AppendLine "* Disconnected " & Time
    End If

    ' Close the current form
    Unload Me

End Sub

Private Sub refComm_MessageRecieved(Sender As clsUser, sMessage As String, bPrivate As Boolean)

    ' Filter messages if needed
    If (Not (Sender.IsEqual(PrivateRecipient) = False And PrivateSession)) And bPrivate = PrivateSession Then
    
        ' Add the message sent
        AppendLine Sender.UserName & ": " & sMessage
    
    Else
    
        ' See if we need to add a window for this conversation
        NewSession Sender.UserName
    
    End If

End Sub

Private Sub refComm_UserListChanged(UserLeft As Variant, UserAdded As Variant)

    On Error Resume Next
    Dim oUser As clsUser, Tell As Long

    ' If this is a private session, we're only interested in one thing
    If PrivateSession Then
    
        ' See if the leaving user equals to the current user
        If UserLeft = PrivateRecipient.UserName Then
        
            ' No point existing further
            Unload Me
        
        End If
    
    Else

        ' Firstly, clear the listbox
        lstUsers.Clear
        
        ' Then add each username to the list
        For Each oUser In refComm.Users
            lstUsers.AddItem oUser.UserName
        Next
    
        ' If users should leave, inform about this
        If LenB(UserLeft) > 0 Then
            AppendLine "* " & UserLeft & " has left the server"
        End If
        
        ' If users should join, inform about this
        If LenB(UserAdded) > 0 Then
            AppendLine "* " & UserAdded & " has joined the server"
        End If
    
    End If
    
End Sub

Private Sub txtCommand_KeyPress(KeyAscii As Integer)

    ' See whether or not the user pressed ENTER
    If KeyAscii = 13 Then
    
        ' Firstly, add the message to the textbox
        AppendLine refComm.LocalUser.UserName & ": " & txtCommand
        
        ' Then send the message
        refComm.SendMessage txtCommand, PrivateName
        
        ' Finally, clear the text and set the focus
        txtCommand.Text = ""
        txtCommand.SetFocus
        
        ' Don't make the "ding" sound
        KeyAscii = 0
        
    End If

End Sub

Public Function NewSession(sName As String) As frmWindow
    
    Dim newForm As frmWindow
    
    ' Make sure the user hasn't already got a form as this
    Set newForm = ChatApp.FindForm(sName)
    
    ' Create or show, depending on the result of the latter
    If newForm Is Nothing Then

        ' Create a new form
        Set newForm = New frmWindow
        Set newForm.refComm = refComm
        
        ' Set the different properties
        Set newForm.PrivateRecipient = refComm.FindUser(sName)
        newForm.PrivateSession = True
        newForm.Caption = newForm.PrivateName
    
        ' Return this form
        Set NewSession = newForm
    
    End If

    ' In any cases, show the form
    newForm.Show

End Function
